/*
 *   Copyright 2009 Joubin Houshyar
 * 
 *   Licensed under the Apache License, Version 2.0 (the "License");
 *   you may not use this file except in compliance with the License.
 *   You may obtain a copy of the License at
 *    
 *   http://www.apache.org/licenses/LICENSE-2.0
 *    
 *   Unless required by applicable law or agreed to in writing, software
 *   distributed under the License is distributed on an "AS IS" BASIS,
 *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *   See the License for the specific language governing permissions and
 *   limitations under the License.
 */

package org.jredis.ri.alphazero.wip;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;
import org.jredis.ri.alphazero.support.FastBufferedInputStream;

/**
 * A {@link ResponseReader} that is backed by a {@link BlockingDeque} of
 * {@link DataBlock}s.
 *
 * @author  Joubin Houshyar (alphazero@sensesay.net)
 * @version alpha.0, Sep 5, 2009
 * @since   alpha.0
 * 
 */

public class BufferedStreamResponseReader implements ResponseReader {

	private final FastBufferedInputStream in;

	public BufferedStreamResponseReader (FastBufferedInputStream in, int maxBlockSize){
		this.in = in;
	}

//	@Override
	public byte readStatus () throws IOException {
		return 0;
	}

//	@Override
	public boolean readBooleanValue () throws IOException {
		return false;
	}

//	@Override
	public long readNumberValue () throws IOException {
		return 0;
	}

//	@Override
	public String readStringValue () throws IOException {
		return null;
	}


//	@Override
	public int readBulkDataSize () {
		// TODO Auto-generated method stub
		return 0;
	}

//	@Override
	public int readMultiBulkDataCount () {
		return 0;
	}

//	@Override
	public byte[] readBulkData (int size) throws IOException {
		byte[] data = new byte[size];
		in.read(data);
		return data;
	}

	byte[] buffer = new byte[128];
	int offset = 0;
	void seekToCRLF (FastBufferedInputStream in) throws IOException {
		/*
		 * We're guaranteed to be able to do blocking reads (as much as possible)
		 * until we get the first CRLF, but we may get some overflow and we need to 
		 * save that.
		 */
		
		int c = -1;
		int available = buffer.length;
		while ((c = in.read(buffer, offset, 1)) != -1) {
			offset += c;
			available -= c;
			if(offset > 2 && buffer[offset-2]==(byte)13 && buffer[offset-1]==(byte)10){
				break;  // we're done
			}
			if(available == 0) {
				byte[] newbuff = new byte[buffer.length * 2];
				System.arraycopy(buffer, 0, newbuff, 0, buffer.length);
				buffer = newbuff;
				available = buffer.length - offset;
			}
		}
	}

//	private byte[] readControlLine (DataSourceInputStream in, byte ctlByte) {
//		ResponseStatus status = null;
//		
//		seekToCRLF(in);
//		if(checkForError && (this.isError = buffer[0] == ProtocolBase.ERR_BYTE) == true) {
//			status = new ResponseStatus(ResponseStatus.Code.ERROR, new String(buffer, 1, offset-3));
//			didRead = true;  // we're done - error's are only one line
//			return -2;
//		}
//		if(buffer[0] != ctlByte) {
//			throw new ProviderException ("Bug?  Expecting status code for size");
//		}
//		status = ResponseStatus.STATUS_OK;
//		return Convert.toInt (buffer, 1, offset-3);
//	}
	// ------------------------------------------------------------------------
	// Input Stream
	// ------------------------------------------------------------------------
	void foo() throws IOException {
		InputStream in = null;
		BufferedInputStream bis = new BufferedInputStream(in);
		byte[] buffer = new byte[100];
		bis.read(buffer, 0, buffer.length);
	}
}
