///*
// *   Copyright 2009 Joubin Houshyar
// * 
// *   Licensed under the Apache License, Version 2.0 (the "License");
// *   you may not use this file except in compliance with the License.
// *   You may obtain a copy of the License at
// *    
// *   http://www.apache.org/licenses/LICENSE-2.0
// *    
// *   Unless required by applicable law or agreed to in writing, software
// *   distributed under the License is distributed on an "AS IS" BASIS,
// *   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// *   See the License for the specific language governing permissions and
// *   limitations under the License.
// */
//
//package org.jredis.ri.alphazero.wip;
//
//import java.io.IOException;
//import java.io.InputStream;
//import java.util.Queue;
//import java.util.concurrent.BlockingQueue;
//import java.util.concurrent.Future;
//import java.util.concurrent.LinkedBlockingQueue;
//import org.jredis.ClientRuntimeException;
//import org.jredis.ProviderException;
//import org.jredis.connector.ConnectionSpec;
//import org.jredis.connector.NotConnectedException;
//import org.jredis.connector.ConnectionSpec.SocketProperty;
//import org.jredis.protocol.Command;
//import org.jredis.protocol.Protocol;
//import org.jredis.protocol.Request;
//import org.jredis.protocol.Response;
//import org.jredis.ri.alphazero.connection.ConnectionBase;
////import org.jredis.ri.alphazero.connection.AsyncRequest;
//import org.jredis.ri.alphazero.protocol.ConcurrentSynchProtocol;
//import org.jredis.ri.alphazero.support.Assert;
//import org.jredis.ri.alphazero.support.FastBufferedInputStream;
//
///**
// * [TODO: document me!]
// *
// * @author  Joubin Houshyar (alphazero@sensesay.net)
// * @version alpha.0, Sep 7, 2009
// * @since   alpha.0
// * 
// */
//
//public  class NullProcPipelineConnection extends ConnectionBase {
//
//	// ------------------------------------------------------------------------
//	// Properties
//	// ------------------------------------------------------------------------
//	private ResponseHandler	    	respHandler;
////	private RequestHandler			reqHandler;
//	private Thread 					respHandlerThread;
////	private Thread 					reqHandlerThread;
//	private BlockingQueue<AsyncRequest>	pendingResponseQueue;
////	private BlockingQueue<PendingRequest>	pendingRequestQueue;		// take this out
//
//	private Object					serviceLock = new Object();
//	// ------------------------------------------------------------------------
//	// Constructor(s)
//	// ------------------------------------------------------------------------
//	/**
//	 * @param spec
//	 * @throws ClientRuntimeException
//	 */
//	public NullProcPipelineConnection (ConnectionSpec spec) throws ClientRuntimeException {
//		super(spec, true);
//	}
//	// ------------------------------------------------------------------------
//	// Extension
//	// ------------------------------------------------------------------------
//	/**
//     * 
//     */
//    protected void initializeComponents () {
//    	super.initializeComponents();
//    	
//    	serviceLock = new Object();
//    	
//    	pendingResponseQueue = new LinkedBlockingQueue<AsyncRequest>();
//    	respHandler = new ResponseHandler();
//    	respHandlerThread = new Thread(respHandler, "response-handler");
//    	respHandlerThread.start();
//    }
//    
//   
//    /**
//     * Pipeline must use a concurrent protocol handler.
//     *  
//     * @see org.jredis.ri.alphazero.connection.ConnectionBase#newProtocolHandler()
//     */
//    protected Protocol newProtocolHandler () {
//		return new ConcurrentSynchProtocol();
//    }
//    
//    /**
//     * Just make sure its a {@link FastBufferedInputStream}.
//     */
//    @Override
//	protected final InputStream newInputStream (InputStream socketInputStream) throws IllegalArgumentException {
////    	
//////    	InputStream in = super.newInputStream(socketInputStream);
//////    	if(!(in instanceof FastBufferedInputStream)){
//////    		System.out.format("WARN: input was: %s\n", in.getClass().getCanonicalName());
//////    		in = new FastBufferedInputStream (in, spec.getSocketProperty(SocketProperty.SO_RCVBUF));
//////    	}
//////    	else {
////    		System.out.format("INFO: input is: %s\n", socketInputStream.getClass().getCanonicalName());
//////    	}
//////    	return in;
//    	return socketInputStream;
//    }
//
//    // ------------------------------------------------------------------------
//	// Interface: Connection
//	// ------------------------------------------------------------------------
//    @Override
//    public final Future<Response> queueRequest (Command cmd, byte[]... args) 
//    	throws ClientRuntimeException, ProviderException 
//    {
////    	int maxWaiting = 0;
//		if(!isConnected()) throw new NotConnectedException ("Not connected!");
//   
//		AsyncRequest pendingResponse = null;
////		Assert.notNull(serviceLock, "servie lock", ProviderException.class);
////		long start = System.nanoTime();
//		respHandler.start();
//		synchronized (serviceLock) {
//			long t1s = System.nanoTime();
//			Request request = Assert.notNull(protocol.createRequest (cmd, args), "request object from handler", ProviderException.class);
////			Request request = protocol.createRequest (cmd, args);
////			long t1e = System.nanoTime();
//			
////			long t2s = System.nanoTime();
//			request.write(super.getOutputStream());
////			long t2e = System.nanoTime();
//			
////			long t3s = System.nanoTime();
////			pendingResponse = new PendingRequest(request, cmd);
////			long t3e = System.nanoTime();
////
////			long t4s = System.nanoTime();
////			pendingResponseQueue.add(pendingResponse);
//////			pendingQueue.add(pendingResponse);  // so we have one writer and one reader -- isn't there a more efficient way to do this?
////			long t4e = System.nanoTime();
//			
////			long end = System.nanoTime();
////			long tot = System.nanoTime() - start;
////			System.out.format("tot:%9d createReq:%6d reqWrite:%9d createPending:%4d qPending:%4d \n", tot, t1e-t1s, t2e-t2s, t3e-t3s, t4e-t4s );
////			System.out.format("    %9d           %6d          %9d               %4d          %4d\n",  tot, 100*(t1e-t1s)/tot, 100*(t2e-t2s)/tot, 100*(t3e-t3s)/tot, 100*(t4e-t4s)/tot );
//		}
////		int waiting = pendingQueue.size();
////		if(waiting > maxWaiting){
////			maxWaiting = waiting;
////			System.out.format("max waiting: %d\n", maxWaiting);
////		}
//		
////		// true asynch
////		// its more elegant and semantically correct but performance bombs for asynch requests and is unstable
////		// due to excessive growth of the pendingReq Q
////		//
////		pendingResponse = new PendingRequest(cmd, args);
////		synchronized(serviceLock){
////			while(true){
////				try {
////						pendingRequestQueue.add(pendingResponse);
////					break;
////				}
////				catch (IllegalStateException e){ 
//////					Thread.yield();
////				}
////			}
////		}
//		return pendingResponse;
//    }
//
//	// ------------------------------------------------------------------------
//	// Inner Class
//	// ------------------------------------------------------------------------
//    
//    public final class ResponseHandler implements Runnable {
//    	private boolean keepWorking = false;
//    	void stop () {
//    		// TODO: 
//    	}
//    	void start () { keepWorking = true; }
//    	/**
//    	 * Keeps processing the {@link AsyncRequest}s in the pending {@link Queue}
//    	 * while {@link ResponseHandler#keepWorking} is <code>true</code>.
//    	 * <p>
//    	 * TODO: not entirely clear what is the best way to handle exceptions.
//    	 * <p>
//    	 * TODO: socket Reconnect in the context of pipelining is non-trivial, and maybe
//    	 * not even practically possible.  (e.g. request n is sent but pipe breaks on
//    	 * some m (m!=n) response.  non trivial.
//    	 */
////        @Override
//        public void run () {
//        	byte[] buffer = new byte[spec.getSocketProperty(SocketProperty.SO_RCVBUF)];
////        	Command cmd;
//        	InputStream in = getInputStream();
////        	if(null == in) {
////        		throw new RuntimeException("input is null");
////        	}
//        	while(keepWorking){
//				try {
////					if(null == buffer) System.out.println ("why is buffer null?");
////					if(null == getInputStream()) System.out.println ("why is input null?");
//					int c = getInputStream().read(buffer, 0, buffer.length);
////					System.out.format("<< %d\n", c);
//				}
//                catch (IOException e) {
//                    e.printStackTrace();
//                }
//                catch (Exception e){
//                	e.printStackTrace();
//                	System.err.format("in thread: %s\n", Thread.currentThread().getName());
//                }
//        	}
//        }
//    }
//
//	/* (non-Javadoc)
//     * @see org.jredis.connector.Connection#getModality()
//     */
////    @Override
//    public Modality getModality () {
//	    return Modality.Asynchronous;
//    }
//}
